//
// basicchannel.h
//
//	Header file for Basic+ I/O
//
// Description:
//
//	Class to handle Basic channels.
//
// History
//
//	03/21/1997 - Kevin Handy
//		Original version.
//
//	04/09/1997 - Kevin Handy
//		Pulled in stuff from basicfun.h
//
#ifndef _BASICCHANNEL_H_
#define _BASICCHANNEL_H_

#ifdef RSTS_FILES
const int MaxChannel = 13;		// Channel 12 is maximum
#else
const int MaxChannel = 100;		// Channel 99 is maximum
#endif

//
// Global Variables
//
int Recount;

class BChannel
{
private:

public:
	//
	// Constructors
	//
	BChannel();
	~BChannel();

	//
	// Open
	//
	int Open();
	int Open(const BString& Name);
	int Open(const char* Name);
	int ForInput();
	int ForOutput();

	//
	// RMS Access
	//
	int Close();
	int Delete();
	int Find();
	int Get();
	int Put();
	int Reset();
	int Unlock();

	//
	// Inputline
	//
	int getline(char* Output, int MaxChar);

	//
	// Special
	//
	char* BufferLoc();
	void SetRecordSize();
	void SetFileSize();
	void SetExtendSize();
	void SetWindowSize();
	void SetBlockSize();
	void SetBucketSize();
	void SetMode();
	void SetBuffer();
	void SetDefaultName();
	void SetKey();
	void SetTemporary();
	void SetContiguous();
	void SetRewind();
	void SetSpan();
	void SetOrginization();
	void SetAccess();
	void SetAllow();
	void SetConnect();
	void SetMap();
	void SetRecordType();
	void GoofyOpenStuff();
	void SetRecord(int);
	int Ccpos();

	friend BChannel& operator<< (BChannel& os, const BString& bs);
	friend BChannel& operator<< (BChannel& os, const char* bs);
	friend BChannel& operator<< (BChannel& os, long bs);
	friend BChannel& operator<< (BChannel& os, double bs);

	friend BChannel& operator>> (BChannel& os, const BString& bs);
};

int unlink(const BString& name);

#define VirtualArray(x) struct virtual ## x
#define Ccpos(x) BasicChannel[x].Ccpos()

#endif
